<?php

global $covert_playeroptin_db_version;

$covert_playeroptin_db_version = '1.6';



function covert_playeroptin_install()

{

    global $wpdb;

    global $covert_playeroptin_db_version;



    $table_name = $wpdb->prefix . 'cptoptinsmenu';



    $sql = "CREATE TABLE " . $table_name . " (

      id int(11) NOT NULL AUTO_INCREMENT,

      name tinytext NULL,

	  optintitle VARCHAR(100) NULL,

      trcp_autorespondercode VARCHAR(8000) NULL,

      trcp_namefield VARCHAR(100) NULL,

	  trcp_emailfield VARCHAR(100) NULL,

  	  trcp_emailfieldtext VARCHAR(1000) NULL,

	  trcp_posturl VARCHAR(500) NULL,

	  trcp_formhiddenfields VARCHAR(1000) NULL,

      PRIMARY KEY  (id)

    );";

    require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

    dbDelta($sql);



    add_option('covert_playeroptin_db_version', $covert_playeroptin_db_version);



    $installed_ver = get_option('covert_playeroptin_db_version');

    if ($installed_ver != $covert_playeroptin_db_version) {

        $sql = "CREATE TABLE " . $table_name . " (

          id int(11) NOT NULL AUTO_INCREMENT,

          name tinytext NULL,

	  	  optintitle VARCHAR(100) NULL,

      	  trcp_autorespondercode VARCHAR(8000) NULL,

      	  trcp_namefield VARCHAR(100) NULL,

	  	  trcp_emailfield VARCHAR(100) NULL,

  	  	  trcp_emailfieldtext VARCHAR(1000) NULL,

	  	  trcp_posturl VARCHAR(500) NULL,

	  	  trcp_formhiddenfields VARCHAR(1000) NULL,

          PRIMARY KEY  (id)

        );";



        require_once(ABSPATH . 'wp-admin/includes/upgrade.php');

        dbDelta($sql);



        update_option('covert_playeroptin_db_version', $covert_playeroptin_db_version);

    }

}



register_activation_hook(__FILE__, 'covert_playeroptin_install');



function covert_playeroptin_update_db_check()

{

    global $covert_playeroptin_db_version;

    if (get_site_option('covert_playeroptin_db_version') != $covert_playeroptin_db_version) {

        covert_playeroptin_install();

    }

}



add_action('plugins_loaded', 'covert_playeroptin_update_db_check');



if (!class_exists('WP_List_Table')) {

    require_once(ABSPATH . 'wp-admin/includes/class-wp-list-table.php');

}



class covert_playeroptin_List_Table extends WP_List_Table

{

    function __construct()

    {

        global $status, $page;



        parent::__construct(array(

            'singular' => 'optin',

            'plural' => 'optins',

        ));

    }



    function column_default($item, $column_name)

    {

        return $item[$column_name];

    }



    function column_optintitle($item)

    {

        return '<em>' . $item['optintitle'] . '</em>';

    }

    function column_name($item)

    {

        $actions = array(

            'edit' => sprintf('<a href="?page=optins_form&id=%s">%s</a>', $item['id'], 'Edit'),

            'delete' => sprintf('<a href="?page=%s&action=delete&id=%s">%s</a>', $_REQUEST['page'], $item['id'], 'Delete'),

        );



        return sprintf('%s %s',

            $item['name'],

            $this->row_actions($actions)

        );

    }



    function column_cb($item)

    {

        return sprintf(

            '<input type="checkbox" name="id[]" value="%s" />',

            $item['id']

        );

    }





    function get_columns()

    {

        $columns = array(

            'cb' => '<input type="checkbox" />',

            'name' => __('Optin ID', 'covert_playeroptin'),

			'optintitle' => __('Optin Title', 'covert_playeroptin'),

        );

        return $columns;

    }



    function get_sortable_columns()



    {

        $sortable_columns = array(

            'name' => array('name', true),

			'optintitle' => array('optintitle', false),

            'trcp_autorespondercode' => array('trcp_autorespondercode', false),

			'trcp_namefield' => array('trcp_namefield', false),

			'trcp_emailfield' => array('trcp_emailfield', false),

			'trcp_emailfieldtext' => array('trcp_emailfieldtext', false),

			'trcp_posturl' => array('trcp_posturl', false),

			'trcp_formhiddenfields' => array('trcp_formhiddenfields', false),

        );

        return $sortable_columns;

    }



    function get_bulk_actions()

    {

        $actions = array(

            'delete' => 'Delete'

        );

        return $actions;

    }



    function process_bulk_action()

    {

        global $wpdb;

        $table_name = $wpdb->prefix . 'cptoptinsmenu'; // do not forget about tables prefix



        if ('delete' === $this->current_action()) {

            $ids = isset($_REQUEST['id']) ? $_REQUEST['id'] : array();

            if (is_array($ids)) $ids = implode(',', $ids);



            if (!empty($ids)) {

                $wpdb->query("DELETE FROM $table_name WHERE id IN($ids)");

            }

        }

    }



    function prepare_items()

    {

        global $wpdb;

        $table_name = $wpdb->prefix . 'cptoptinsmenu';



        $per_page = 100;



        $columns = $this->get_columns();

        $hidden = array();

        $sortable = $this->get_sortable_columns();



        $this->_column_headers = array($columns, $hidden, $sortable);



        $this->process_bulk_action();



        $total_items = $wpdb->get_var("SELECT COUNT(id) FROM $table_name");



        $paged = isset($_REQUEST['paged']) ? max(0, intval($_REQUEST['paged']) - 1) : 0;

        $orderby = (isset($_REQUEST['orderby']) && in_array($_REQUEST['orderby'], array_keys($this->get_sortable_columns()))) ? $_REQUEST['orderby'] : 'name';

        $order = (isset($_REQUEST['order']) && in_array($_REQUEST['order'], array('asc', 'desc'))) ? $_REQUEST['order'] : 'asc';



        $this->items = $wpdb->get_results($wpdb->prepare("SELECT * FROM $table_name ORDER BY $orderby $order LIMIT %d OFFSET %d", $per_page, $paged), ARRAY_A);



        $this->set_pagination_args(array(

            'total_items' => $total_items,

            'per_page' => $per_page,

            'total_pages' => ceil($total_items / $per_page)

        ));

    }

}



function covert_player_optins_page_handler()

{

    global $wpdb;



    $table = new covert_playeroptin_List_Table();

    $table->prepare_items();



    $message = '';

    if ('delete' === $table->current_action()) {

        $message = '<div class="updated below-h2" id="message"><p>' . sprintf(__('Records deleted: %d', 'covert_playeroptin'), count($_REQUEST['id'])) . '</p></div>';

    }

    ?>

<div class="wrap">



    <div class="icon32 icon32-posts-post" id="icon-edit"><br></div>

    <h2><?php _e('Optins', 'covert_playeroptin')?> <a class="add-new-h2"

                                 href="<?php echo get_admin_url(get_current_blog_id(), 'admin.php?page=optins_form');?>"><?php _e('Add/Edit Optin', 'covert_playeroptin')?></a>

    </h2>

    <?php echo $message; ?>



    <form id="optins-table" method="GET">

        <input type="hidden" name="page" value="<?php echo $_REQUEST['page'] ?>"/>

        <?php $table->display() ?>

    </form>



</div>

<?php

}



function covert_player_optins_form_page_handler()

{

    global $wpdb;

    $table_name = $wpdb->prefix . 'cptoptinsmenu';



    $message = '';

    $notice = '';



    $default = array(

        'id' => 0,

        'name' => null,

		'optintitle' => null,

        'trcp_autorespondercode' => null,

        'trcp_namefield' => null,

		'trcp_emailfield' => null,

		'trcp_emailfieldtext' => null,

        'trcp_posturl' => null,

		'trcp_formhiddenfields' => null,

    );



    if (wp_verify_nonce($_REQUEST['nonce'], basename(__FILE__))) {



        $item = shortcode_atts($default, $_REQUEST);

        $item_valid = covert_playeroptin_validate_optin($item);

        if ($item_valid === true) {

            if ($item['id'] == 0) {

                $result = $wpdb->insert($table_name, $item);

                $item['id'] = $wpdb->insert_id;

                //if ($result) {

                    $message = __('Record was successfully saved', 'covert_playeroptin');

                //} else {

                 //   $notice = __('There was an error while saving record', 'covert_playeroptin');

               // }

            } else {

                $result = $wpdb->update($table_name, $item, array('id' => $item['id']));

                //if ($result) {

                    $message = __('Record was successfully updated', 'covert_playeroptin');

                //} else {

                  //  $notice = __('There was an error while updating record', 'covert_playeroptin');

               // }

            }

        } else {



            $notice = $item_valid;

        }

    }

    else {



        $item = $default;

        if (isset($_REQUEST['id'])) {

            $item = $wpdb->get_row($wpdb->prepare("SELECT * FROM $table_name WHERE id = %d", $_REQUEST['id']), ARRAY_A);

            if (!$item) {

                $item = $default;

                $notice = __('Item not found', 'covert_playeroptin');

            }

        }

    }



    add_meta_box('optins_form_meta_box', 'Add/Edit Optin', 'covert_playeroptin_optins_form_meta_box_handler', 'optin', 'normal', 'default');



    ?>

<div class="wrap">

    <div class="icon32 icon32-posts-post" id="icon-edit"><br></div>

    <h2><?php _e('Optin', 'covert_playeroptin')?> <a class="add-new-h2"

                                href="<?php echo get_admin_url(get_current_blog_id(), 'admin.php?page=optins');?>"><?php _e('back to list', 'covert_playeroptin')?></a>

    </h2>



    <?php if (!empty($notice)): ?>

    <div id="notice" class="error"><p><?php echo $notice ?></p></div>

    <?php endif;?>

    <?php if (!empty($message)): ?>

    <div id="message" class="updated"><p><?php echo $message ?></p></div>

    <?php endif;?>



    <form id="form" method="POST">

        <input type="hidden" name="nonce" value="<?php echo wp_create_nonce(basename(__FILE__))?>"/>

        <?php /* NOTICE: here we storing id to determine will be item added or updated */ ?>

        <input type="hidden" name="id" value="<?php echo $item['id'] ?>"/>



        <div class="metabox-holder" id="poststuff">

            <div id="post-body">

                <div id="post-body-content">

                    <?php /* And here we call our custom meta box */ ?>

                    <?php do_meta_boxes('optin', 'normal', $item); ?>

                    <input type="submit" value="<?php _e('Save Changes', 'covert_playeroptin')?>" id="submit" class="button-primary" name="submit">

                </div>

            </div>

        </div>

    </form>

</div>

<?php

}



function covert_playeroptin_optins_form_meta_box_handler($item)

{

	global $wpdb;

    $second_table = $wpdb->prefix . 'cptoptinsmenu';

	$videomaxid = $wpdb->get_var( "SELECT max(id) FROM $second_table" );

	if($videomaxid == '' || $videomaxid == '0') { $videomaxid = '0'; }

	$videomaxids = (int)$videomaxid + 1;

	$mylatestcpoptid = 'cpoptin'. $videomaxids;

    ?>

<table cellspacing="2" cellpadding="5" style="width: 100%;" class="form-table">

    <tbody>

    <tr class="form-field">

        <th valign="top" scope="row">

            <label for="name"><?php _e('Optin ID', 'covert_playeroptin')?></label>

        </th>

        <td>

            <input id="name" name="name" type="text" style="width: 95%" readonly="readonly" value="<?php if(esc_attr($item['name']) != '') { echo esc_attr($item['name']); } else { echo $mylatestcpoptid;}?>" size="50" class="code">

        </td>

    </tr>

    <tr class="form-field">

        <th valign="top" scope="row">

            <label for="headertext"><?php _e('Optin Title', 'covert_playeroptin')?></label>

        </th>

        <td>

            <input id="optintitle" name="optintitle" type="text" style="width: 95%" value="<?php echo esc_attr($item['optintitle']);?>"

                   size="50" class="code">

        </td>

    </tr>

    <tr class="form-field">

        <th valign="top" scope="row">

            <label for="trcp_autorespondercode"><?php _e('Autoresponder Code', 'covert_playeroptin')?></label>

        </th>

        <td>

            <textarea rows="3" cols="60" name="trcp_autorespondercode" id="trcp_autorespondercode"><?php echo stripslashes($item['trcp_autorespondercode']); ?></textarea>

        </td>

    </tr>

    

    <tr class="form-field" style="display:none;">

        <th valign="top" scope="row">

            <label for="trcp_namefield"><?php _e('Name Field', 'covert_playeroptin')?></label>

        </th>

        <td>

            <input type="text" name="trcp_namefield" id="trcp_namefield" value="<?php echo esc_attr($item['trcp_namefield']); ?>" size="60" />

        </td>

    </tr>

    <tr class="form-field">

        <th valign="top" scope="row">

            <label for="trcp_emailfield"><?php _e('Email Field', 'covert_playeroptin')?></label>

        </th>

        <td>

            <input type="text" name="trcp_emailfield" id="trcp_emailfield" value="<?php echo esc_attr($item['trcp_emailfield']); ?>" size="60" />

        </td>

    </tr>

    

    <tr class="form-field">

        <th valign="top" scope="row">

            <label for="trcp_emailfieldtext"><?php _e('Email Field Text', 'covert_playeroptin')?></label>

        </th>

        <td>

            <input type="text" name="trcp_emailfieldtext" id="trcp_emailfieldtext" value="<?php echo esc_attr($item['trcp_emailfieldtext']); ?>" size="60" />

        </td>

    </tr>

    

    <tr class="form-field">

        <th valign="top" scope="row">

            <label for="trcp_posturl"><?php _e('Post URL', 'covert_playeroptin')?></label>

        </th>

        <td>

            <input type="text" name="trcp_posturl" id="trcp_posturl" value="<?php echo esc_attr($item['trcp_posturl']); ?>" size="60" />

        </td>

    </tr>

    

    <tr class="form-field">

        <th valign="top" scope="row">

            <label for="trcp_formhiddenfields"><?php _e('Hidden Fields', 'covert_playeroptin')?></label>

        </th>

        <td>

        	<div style="display:none" id="popup_domination_hdn_div11"></div><div style="display:none" id="popup_domination_hdn_div12"></div>

            <textarea rows="3" cols="60" name="trcp_formhiddenfields" id="trcp_formhiddenfields"><?php echo stripslashes($item['trcp_formhiddenfields']); ?></textarea>

        </td>

    </tr>

    </tbody>

</table>

<?php

}



function covert_playeroptin_validate_optin($item)

{

    $messages = array();



    if (empty($item['name'])) $messages[] = __('Optin ID is required', 'covert_playeroptin');

    //if (empty($item['headertext'])) $messages[] = __('Header Text is required', 'covert_playeroptin');

    //if (!ctype_digit($item['enableskip'])) $messages[] = __('Age in wrong format', 'covert_playeroptin');

	

    //if(!empty($item['enableskip']) && !absint(intval($item['enableskip'])))  $messages[] = __('Age can not be less than zero');

    //if(!empty($item['enableskip']) && !preg_match('/[0-9]+/', $item['enableskip'])) $messages[] = __('Age must be number');

    //...



    if (empty($messages)) return true;

    return implode('<br />', $messages);

}



function covert_playeroptin_languages()

{

    load_plugin_textdomain('covert_playeroptin', false, dirname(plugin_basename(__FILE__)));

}



add_action('init', 'covert_playeroptin_languages');